--[[
    七天目标
]]
ActionSevenGoalWindow = ActionSevenGoalWindow or BaseClass(BaseView)

local role_vo = RoleController:getInstance():getRoleVo()

local data_constant = Config.DayGoalsData.data_constant

local table_insert = table.insert
local controller = ActionController:getInstance()
local model = controller:getModel()
function ActionSevenGoalWindow:__init()
    self.is_full_screen = true
    self.win_type = WinType.Full
    self.cur_index = nil
    self.cur_select = nil
    self.cur_grop_select = nil
    self.play_effect = {} --宝箱
    self.welfareList = nil
    self.growthTarget = nil
    self.priceList = nil
    self.item_scrollview_walfare = nil
    self.item_scrollview_walfare2 = nil
    self.currentDay = 1 --当前天数
    self.initCurrentDay = 1 --初始化天数，保证天数回滚是不会改变
    
    --关于周期性的图片动态加载
    self.load_touch_day = {}
    self.layout_name = "action/action_seven_goal_window"
    self.res_list = {
        {path = PathTool.getPlistImgForDownLoad("gw_action_seven_goal", "gw_action_seven_goal"), type = ResourcesType.plist},
        {path = PathTool.getPlistImgForDownLoad("gw_action_time_limit", "gw_action_time_limit"), type = ResourcesType.plist},
        {path = PathTool.getPlistImgForDownLoad("gw_action_seven_goal","gw_action_seven_goal_01", true), type = ResourcesType.single},
        {path = PathTool.getPlistImgForDownLoad("gw_action_seven_goal","gw_action_seven_goal_02", false), type = ResourcesType.single},
        { path = PathTool.getPlistImgForDownLoad("gw_task","gw_task"), type = ResourcesType.plist },
    }
end

function ActionSevenGoalWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            controller:openSevenGoalView(false)
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)

    self.tips_btn = self.left_top_container:getChildByName("tips_btn")
    self.tips_btn:setVisible(false)
    --self.tips_btn:addTouchEventListener(function(sender, event_type)
    --    customClickAction(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        local config = Config.GuildSkillData.data_const.game_rule
    --        if config then
    --            TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition(), nil, nil, 800)
    --        end
    --    end
    --end)

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
        --self.top_num_wealth_list[i].btn:setVisible(false)
    end
    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_action_seven_goal", "gw_action_seven_goal_01", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    --人物精灵
    self.girl_icon = self.root_wnd:getChildByName("girl_icon")
    local girl_icon_res = PathTool.getPlistImgForDownLoad("gw_action_seven_goal", "gw_action_seven_goal_02", false)
    self.girl_icon_load = loadSpriteTextureFromCDN(self.girl_icon, girl_icon_res, ResourcesType.single, self.girl_icon_load)

    self.root_wnd:getChildByName("texture1"):setPositionX(display.getLeft() - 3)
    self.seven_goal_time_bg = self.root_wnd:getChildByName("seven_goal_time_bg")
    self.seven_goal_time_bg:setPositionX(display.getLeft())
    --self.seven_goal_time_label = self.seven_goal_time_bg:getChildByName("seven_goal_time_label")
    --self.seven_goal_time_label:setString(UI_TI18N(42001))
    self.sevenGoalTime = self.seven_goal_time_bg:getChildByName("seven_goal_time")
    --self.sevenGoalTime:setPositionX(self.seven_goal_time_label:getPositionX() + self.seven_goal_time_label:getContentSize().width)

    self.sheet_container = self.root_wnd:getChildByName("sheet_container")
    self.sheet_list = {}
    --天数对应名字
    local sheet_name_list = {UI_TI18N(42002),UI_TI18N(42003),UI_TI18N(42004),UI_TI18N(42005),UI_TI18N(42006),UI_TI18N(42007),UI_TI18N(42008)}
    for i=1,7 do
        self.sheet_list[i] = self.sheet_container:getChildByName("day"..i)
        self.sheet_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                --if i > self.initCurrentDay then
                --    message(UI_TI18N(42009))
                --    return
                --end
                self:noArriveDayGray(i)
            end
        end)
        self.sheet_list[i].closed_bg = self.sheet_list[i]:getChildByName("closed_bg")
        self.sheet_list[i].closed_bg:setVisible(false)
        self.sheet_list[i].opened_bg = self.sheet_list[i]:getChildByName("opened_bg")
        self.sheet_list[i].opened_bg:setVisible(false)
        self.sheet_list[i].label = self.sheet_list[i]:getChildByName("label")
        self.sheet_list[i].label:setString(sheet_name_list[i])
        self.sheet_list[i].select = self.sheet_list[i]:getChildByName("select")
        self.sheet_list[i].select:setVisible(false)
        self.sheet_list[i].red_point = self.sheet_list[i]:getChildByName("red_point")
        self.sheet_list[i].red_point:setVisible(false)
    end

    self.tab_container = self.root_wnd:getChildByName("tab_container")
    self.tab_container_scrollview = self.tab_container:getChildByName("scrollview")
    self.tab_container_scrollview:setScrollBarEnabled(false)
    self.tab_btn_list = {}
    --天数对应名字
    local tab_name_list = {UI_TI18N(42010),"","",UI_TI18N(42011)}
    for i=1,4 do
        self.tab_btn_list[i] = self.tab_container_scrollview:getChildByName("tab"..i)
        self.tab_btn_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:selectByBtn(i)
            end
        end)
        self.tab_btn_list[i].normal = self.tab_btn_list[i]:getChildByName("normal")
        self.tab_btn_list[i].normal:setVisible(false)
        self.tab_btn_list[i].normal_label = self.tab_btn_list[i].normal:getChildByName("label")
        self.tab_btn_list[i].normal_label:setString(tab_name_list[i])
        self.tab_btn_list[i].select = self.tab_btn_list[i]:getChildByName("select")
        self.tab_btn_list[i].select:setVisible(false)
        self.tab_btn_list[i].select_label = self.tab_btn_list[i].select:getChildByName("label")
        self.tab_btn_list[i].select_label:setString(tab_name_list[i])
        self.tab_btn_list[i].red_point = self.tab_btn_list[i]:getChildByName("redpoint")
        self.tab_btn_list[i].red_point:setVisible(false)

        self.tab_btn_list[i].normal_label:setFontSize(28)
        self.tab_btn_list[i].select_label:setFontSize(28)
        if self.tab_btn_list[i].normal_label:getContentSize().width > 200 then
            for k=1,15 do
                self.tab_btn_list[i].normal_label:setFontSize(28-k)
                self.tab_btn_list[i].select_label:setFontSize(28-k)
                if self.tab_btn_list[i].normal_label:getContentSize().width <= 200 then
                    break
                end
            end
        end
    end
    self.tab_container_to_left_btn = self.tab_container:getChildByName("to_left_btn")
    self.tab_container_to_left_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self.tab_container_scrollview:jumpToLeft()
        end
    end)
    self.tab_container_to_right_btn = self.tab_container:getChildByName("to_right_btn")
    self.tab_container_to_right_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self.tab_container_scrollview:jumpToRight()
        end
    end)


    self.box_infos = self.root_wnd:getChildByName("box_infos")
    self.box_infos_bar = self.box_infos:getChildByName("bar")
    self.box_infos_today_active_label = self.box_infos:getChildByName("today_active_label")
    self.box_infos_box_list = {}
    for i=1,4 do
        self.box_infos_box_list[i] = self.box_infos:getChildByName("box"..i)
        self.box_infos_box_list[i].item_node = self.box_infos_box_list[i]:getChildByName("item_node")
        --self.box_infos_box_list[i].icon = self.box_infos_box_list[i]:getChildByName("icon")
        self.box_infos_box_list[i].num = self.box_infos_box_list[i]:getChildByName("num")
        self.box_infos_box_list[i].red_point = self.box_infos_box_list[i]:getChildByName("redpoint")
        self.box_infos_box_list[i].btn = self.box_infos_box_list[i]:getChildByName("btn")
        self.box_infos_box_list[i].btn:addTouchEventListener(function(sender, event_type)
            --customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                local all_target = model:getBoxRewardData()
                if all_target and all_target[i] and all_target[i].id then
                    --local function callback()
                    --    controller:cs13602(5, self.currentDay,all_target[i].id,0)
                    --end

                    local can_get = false
                    local box_list = model:getSevenGoalBoxList()
                    if box_list ~= nil and next(box_list) ~= nil and box_list[i] ~= nil then
                        if box_list[i] and box_list[i].status == 1 then--可领取
                            can_get = true
                        end
                    end

                    if can_get == true then
                        controller:cs13602(5, self.currentDay,all_target[i].id,0)
                    else
                        CommonAlert.showItemApply(UI_TI18N(18006),all_target[i].award,nil,nil,nil,nil,UI_TI18N(18007),nil,nil,true,nil, nil,{off_y=70})
                    end
                    --CommonAlert.showItemApply(TI18N("当前活跃度奖励"), all_target[k].award, callback,TI18N("确定"),
                    --        nil,nil,TI18N("奖励"),nil,nil,true,nil, nil,{off_y=50})
                end
            end
        end)
    end

    self.list_container = self.root_wnd:getChildByName("list_container")
    self.list_container_size = self.list_container:getContentSize()
    local setting = {
        item_class = ActionSevenGoalItem,      -- 单元类
        start_x = 19,                  -- 第一个单元的X起点
        space_x = 0,                    -- x方向的间隔
        start_y = 18,                    -- 第一个单元的Y起点
        space_y = 17,                   -- y方向的间隔
        item_width = 726,               -- 单元的尺寸width
        item_height = 112,              -- 单元的尺寸height
        row = 0,                        -- 行数，作用于水平滚动类型
        col = 1,                         -- 列数，作用于垂直滚动类型
    }
    self.item_scrollview_walfare = CommonScrollViewLayout.new(self.list_container, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, self.list_container_size, setting)
    self.item_scrollview_walfare:setSwallowTouches(false)
    self.item_scrollview_walfare:setVisible(false)

    local setting = {
        item_class = ActionSevenGoalItem2,      -- 单元类
        start_x = 19,                  -- 第一个单元的X起点
        space_x = 0,                    -- x方向的间隔
        start_y = 18,                    -- 第一个单元的Y起点
        space_y = 15,                   -- y方向的间隔
        item_width = 726,               -- 单元的尺寸width
        item_height = 144,              -- 单元的尺寸height
        row = 0,                        -- 行数，作用于水平滚动类型
        col = 1,                         -- 列数，作用于垂直滚动类型
    }
    self.item_scrollview_walfare2 = CommonScrollViewLayout.new(self.list_container, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, self.list_container_size, setting)
    self.item_scrollview_walfare2:setSwallowTouches(false)
    self.item_scrollview_walfare2:setVisible(false)

    --self.background = self.root_wnd:getChildByName("background")
    --
    --self.bg_sprite = self.root_wnd:getChildByName("Image_bg")
    --if self.bg_sprite ~= nil then
    --    self.bg_sprite:setScale(display.getMaxScale())
    --end
    --
    --self.main_container = self.background:getChildByName("main_container")
    --self:playEnterAnimatianByObj(self.main_container, 1)
    --self.layer_tab = self.main_container:getChildByName("layer_tab")
    --
    ----宝箱
    --self.award_list = {108,108,108,110}
    --local box_ave_x = 559 / 4
    --self.box_list_layer = {}
    --for i=1, 4 do
    --    local tab = self.background:getChildByName("box_"..i)
    --    tab:setPositionX(80+box_ave_x * i)
    --    tab.redpoint = tab:getChildByName("redpoint")
    --    tab.redpoint:setLocalZOrder(11)
    --    tab.redpoint:setVisible(false)
    --    tab.textNum = tab:getChildByName("textNum")
    --    tab.textNum:setLocalZOrder(11)
    --    tab.textNum:setString("")
    --    self.box_list_layer[i] = tab
    --end
    --
    --self.goods_walfare = self.main_container:getChildByName("goods_walfare")
    --self.close_btn = self.main_container:getChildByName("close_btn")
    --
    --self.btn_list = {}
    --local btn_label_list = {TI18N("福利领取"),TI18N(""),TI18N(""),TI18N("福利礼包")}
    --for i=1,4 do
    --    local btn = self.layer_tab:getChildByName("btnSelect_"..i)
    --    btn.red_point = btn:getChildByName("redpoint")
    --    btn.red_point:setVisible(false)
    --    btn.normal = btn:getChildByName("normal")
    --    btn.select = btn:getChildByName("select")
    --    btn.select:setVisible(false)
    --    btn.title = btn:getChildByName("title")
    --    btn.title:setString(btn_label_list[i])
    --    btn.title:setTextColor(cc.c4b(0xEE, 0xD1, 0xAF, 0xff))
    --    btn.title:enableOutline(cc.c4b(0x53, 0x3D, 0x32, 0xff), 2)
    --    btn.index = i
    --    self.btn_list[i] = btn
    --end
    --
    --local layerReward = self.background:getChildByName("layerReward")
    --self.touchTotleDay = {}
    --for i=1, 7 do
    --    local tab = {}
    --    tab.btn = layerReward:getChildByName("reward_"..i)
    --    tab.red_point = tab.btn:getChildByName("redpoint")
    --    tab.red_point:setVisible(false)
    --
    --    local textDay = tab.btn:getChildByName("day")
    --    textDay:setString(TI18N("第")..i..TI18N("天"))
    --
    --    tab.rewardImage = tab.btn:getChildByName("rewardImage")
    --    tab.show_day_icon = tab.btn:getChildByName("rewardItem")
    --    tab.show_day_icon:setScale(0.8)
    --    self.touchTotleDay[i] = tab
    --end
    --
    --self.finish_round = self.background:getChildByName("finish_round")
    --self.day_title = self.background:getChildByName("day_title")
    --self.main_container:getChildByName("Text_19"):setString(TI18N("剩余时间: "))
    --self.background:getChildByName("Text_1"):setString(TI18N("完成个数"))
    --
    --self.sevenGoalTime = self.main_container:getChildByName("sevenGoalTime")
    --self.bar = self.background:getChildByName("bar")
    --self.bar:setScale9Enabled(true)
    --self.successNum = self.background:getChildByName("successNum")
    --
    --local bgSize = self.goods_walfare:getContentSize()
    --local scroll_view_size_walfara = cc.size(bgSize.width, bgSize.height)
    --local setting = {
    --    item_class = ActionSevenGoalItem,      -- 单元类
    --    start_x = 6,                  -- 第一个单元的X起点
    --    space_x = 0,                    -- x方向的间隔
    --    start_y = 0,                    -- 第一个单元的Y起点
    --    space_y = 5,                   -- y方向的间隔
    --    item_width = 641,               -- 单元的尺寸width
    --    item_height = 156,              -- 单元的尺寸height
    --    row = 0,                        -- 行数，作用于水平滚动类型
    --    col = 1,                         -- 列数，作用于垂直滚动类型
    --}
    --self.item_scrollview_walfare = CommonScrollViewLayout.new(self.goods_walfare, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, scroll_view_size_walfara, setting)
    --self.item_scrollview_walfare:setSwallowTouches(false)
end


function ActionSevenGoalWindow:register_event()
    self:addGlobalEvent(ActionEvent.UPDATE_SEVENT_GOAL, function(data)
        self:seventGoal(data)
    end)

    self:addGlobalEvent(ActionEvent.UPDATE_SEVENT_GET, function(data)
        self:seventGet(data)
    end)

    --for k,v in pairs(self.btn_list) do
    --    registerButtonEventListener(v, function()
    --        self:selectByBtn(k)
    --    end,false, 1)
    --end
    --
    --for k,v in pairs(self.touchTotleDay) do
    --    registerButtonEventListener(v.btn, function()
    --        if k > self.initCurrentDay then
    --            message(TI18N("未达到开放天数"))
    --            return
    --        end
    --        self:noArriveDayGray(k)
    --    end,false, 1)
    --end
    --
    --for k,v in pairs(self.box_list_layer) do
    --    registerButtonEventListener(v, function()
    --        local all_target = model:getBoxRewardData()
    --        if all_target and all_target[k] and all_target[k].id then
    --            local function callback()
    --                controller:cs13602(5, self.currentDay,all_target[k].id,0)
    --            end
    --            CommonAlert.showItemApply(TI18N("当前活跃度奖励"), all_target[k].award, callback,TI18N("确定"),
    --                nil,nil,TI18N("奖励"),nil,nil,true,nil, nil,{off_y=50})
    --        end
    --    end,true, 1)
    --end
    --
    --registerButtonEventListener(self.close_btn, function()
    --    controller:openSevenGoalView(false)
    --end,true, 2)

    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if not self.top_num_wealth_list then return end
                if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "hero_exp" then
                    self:updateTopNumWealth()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.hero_exp)
            if config then
                BackpackController:getInstance():openTipsSource(true, config)
            end
        end
    end)
    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end
end

function ActionSevenGoalWindow:openRootWnd()
    ExchangeController:getInstance():send23606()
    controller:cs13601()
    self:updateTopNumWealth()
end

function ActionSevenGoalWindow:seventGoal(data)
    if not data then return end
    if not data or data.cur_day > 7 or data.cur_day < 1 then
        controller:openSevenGoalView(false)
        return
    end
    --doStopAllActions(self.layer_tab)
    --data.period = data.period or 1
    --if data.period == 7 then
    --    data.period = 4
    --end
    --local str_res = string.format("seven_goals/%d",data.period)
    --if not self.item_load then
    --    local res1 = PathTool.getPlistImgForDownLoad(str_res,"action_seven_goal_bg1")
    --    self.item_load = loadSpriteTextureFromCDN(self.bg_sprite, res1, ResourcesType.single, self.item_load)
    --end

    local all_target = model:getBoxRewardData()
    for i=1,4 do
        if self.box_infos_box_list[i] and all_target[i] then
            self.box_infos_box_list[i].num:setString(all_target[i].goal)
        end
    end

    --local config = data_constant.day_item
    --if data.period == 2 then
    --    config = data_constant.day_item1
    --elseif data.period == 3 then
    --    config = data_constant.day_item2
    --elseif data.period == 4 then
    --    config = data_constant.day_item3
    --end
    --for i=1,7 do
    --    local item_config = Config.ItemData.data_get_data(config.val[i])
    --    if item_config then
    --        local res = PathTool.getItemRes(item_config.icon)
    --        if self.touchTotleDay[i] then
    --            delayRun(self.layer_tab,i / display.DEFAULT_FPS,function ()
    --                loadSpriteTexture(self.touchTotleDay[i].show_day_icon,res, LOADTEXT_TYPE)
    --            end)
    --        end
    --    end
    --end
    --
    --delayRun(self.layer_tab,2 / display.DEFAULT_FPS,function ()
    --    if not self.load_round_finish then
    --        local res2 = PathTool.getPlistImgForDownLoad(str_res,"seven_goals_1_3")
    --        self.load_round_finish = loadSpriteTextureFromCDN(self.finish_round, res2, ResourcesType.single, self.load_round_finish)
    --    end
    --end)
    --
    --delayRun(self.layer_tab,3 / display.DEFAULT_FPS,function ()
    --    if not self.load_day_title then
    --        local res3 = PathTool.getPlistImgForDownLoad(str_res,"seven_goals_1_4")
    --        self.load_day_title = loadSpriteTextureFromCDN(self.day_title, res3, ResourcesType.single, self.load_day_title)
    --        self.day_title:setScaleX(8.0)
    --    end
    --end)

    local rove_ro = RoleController:getInstance():getRoleVo()
    self.goalEndTime = data.end_time or 0
    self.currentDay = data.cur_day or 1
    self.initCurrentDay = data.cur_day or 1
    self:noArriveDayGray(self.currentDay)

    self.success_num = data.num or 1
    self.box_infos_today_active_label:setString(self.success_num)
    self.box_infos_bar:setPercent(self:setSemgentPercent(self.success_num))

    self:upateGoalEndTime()

    local box_list = model:getSevenGoalBoxList()
    self:updateTaskList(box_list)

    if self.cur_index == nil then
        self:selectByBtn(1)
    else
        self:selectByBtn(self.cur_index)
    end
    local initDayRed = self:initRedPointDay(self.currentDay)
    for i,v in ipairs(initDayRed) do
        if v then
            if v == true and self.sheet_list[i].red_point_spine == nil then
                self.sheet_list[i].red_point_spine = PathTool.gw_createRedpointSpine()
                self.sheet_list[i].red_point:addChild(self.sheet_list[i].red_point_spine)
            end
            self.sheet_list[i].red_point:setVisible(v)
        end
        --if v and self.touchTotleDay[i] then
        --    self.touchTotleDay[i].red_point:setVisible(v)
        --end
    end
    self:redPointTabDayList(self.currentDay)
end

function ActionSevenGoalWindow:upateGoalEndTime()
    if not self.goalEndTime then return end
    if not self.sevenGoalTime then return end
    doStopAllActions(self.sevenGoalTime)
    if self.goalEndTime > 0 then
        self.sevenGoalTime:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(1),
        cc.CallFunc:create(function()
            self.goalEndTime = self.goalEndTime - 1
            if self.goalEndTime <= 0 then
                doStopAllActions(self.sevenGoalTime)
                self.sevenGoalTime:setString("00:00:00")
            else
                self.sevenGoalTime:setString(TimeTool.GetTimeFormat(self.goalEndTime))
            end
        end))))
        self:sevenGoalRemainTime()
    else
        doStopAllActions(self.sevenGoalTime)
        self.sevenGoalTime:setString("00:00:00")
    end
end

function ActionSevenGoalWindow:seventGet(data)
    if not data then return end
    self.success_num = data.num or 1
    self.box_infos_today_active_label:setString(self.success_num)
    self.box_infos_bar:setPercent(self:setSemgentPercent(self.success_num))
    local sort_list = {}
    local config_data = {}
    local serve_data = {}
    local sort_updata_data = {}

    if data.type == 1 or data.type == 2 or data.type == 3 then
        if data.type == 1 then
            config_data = model:getWalfareData(data.day_type)
            serve_data = model:getSevenGoalWelfareList(data.day_type)
        elseif data.type == 2 then
            config_data = model:getWalfareGrowUpData(data.day_type)
            serve_data = model:getServerGrowListData(data.day_type)
        elseif data.type == 3 then
            config_data = model:getWelfareGiftData(data.day_type)
            serve_data = model:getServerGiftListData(data.day_type)
        end
        local index = 1
        for i,v in ipairs(serve_data) do
            if v and v.goal_id and v.goal_id == data.id then
                index = i
                break
            end
        end
        if data.type == 1 then
            model:updataGoalWelfareList(data.day_type, index, data.status)
            sort_updata_data = model:getSevenGoalWelfareList(self.currentDay)
        elseif data.type == 2 then
            model:updataGrowListData(data.day_type, index, data.status)
            sort_updata_data = model:getServerGrowListData(data.day_type)
        elseif data.type == 3 then
            model:updataGiftListData(data.day_type, index, data.status)
            sort_updata_data = model:getServerGiftListData(data.day_type)
        end
        sort_updata_data = self:reverseTable(deepCopy(sort_updata_data))
        sort_updata_data = self:sortFunc(sort_updata_data)
        for i,v in ipairs(sort_updata_data) do
            for k,val in ipairs(config_data) do
                if v.goal_id == val.goal_id then
                    table_insert(sort_list, val)
                end
            end
        end
        config_data = sort_list
        local status = false
        for i, v in ipairs(sort_updata_data) do
            if v.status == 1 then
                status = true
                break
            end
        end
        if data.type == 1 then
            model:updataRedPointWelfareStatus(data.day_type, status)
        elseif data.type == 2 then
            model:updataRedPointGrowStatus(data.day_type, status)
        elseif data.type == 3 then
            model:updataRedPointGiftStatus(data.day_type, status)
        end
        local tab = {}
        tab.list = deepCopy(sort_updata_data)
        tab.type = self.cur_index
        tab.day = data.day_type
        tab.init_cur_day = self.initCurrentDay
        self.item_scrollview_walfare:setData(config_data, nil, nil, tab)
        self.item_scrollview_walfare:setVisible(true)
        self.item_scrollview_walfare2:setVisible(false)
    elseif data.type == 4 then
        local half_data = model:getWelfareHalfData(data.day_type)
        local half_list = model:getHalfGiftList(data.day_type)

        local index = 1
        for i,v in ipairs(half_list) do
            if v.day == data.id then
                index = i
                break
            end
        end
        model:updataHalfListData(data.day_type, index, data.status)
        local half_updata_list = model:getHalfGiftList(data.day_type)

        table.sort( half_updata_list, function(a,b)
            if a.status < b.status then
                return a.status < b.status
            end
        end )

        for i,v in ipairs(half_updata_list) do
            for k,val in ipairs(half_data) do
                if v.day == val.id then
                    table_insert(sort_list, val)
                end
            end
        end
        half_data = sort_list

        local status = false
        for i, v in ipairs(half_updata_list) do
            if v.day <= 7 and v.status == 0 then
                status = true
                break
            end
        end
        model:updataRedPointHalfStatus(data.day_type, status)

        local tab = {}
        tab.list = deepCopy(half_updata_list)
        tab.type = self.cur_index
        tab.day = data.day_type
        tab.init_cur_day = self.initCurrentDay
        self.item_scrollview_walfare2:setData(half_data, nil, nil, tab)
        self.item_scrollview_walfare:setVisible(false)
        self.item_scrollview_walfare2:setVisible(true)

    elseif data.type == 5 then --宝箱
        local all_target = model:getBoxRewardData()
        local count_num = 1
        for i,v in ipairs(all_target) do
            if v.id == data.id then
                count_num = i
                break
            end
        end

        model:updataBoxListData(count_num, data.status)
        local box_list = model:getSevenGoalBoxList()
        self:updateTaskList(box_list)
        model:updataRedPointBoxStatus(count_num, box_list[count_num].status)
    end
    local all_target = model:getBoxRewardData()
    if self.success_num == all_target[1].goal or self.success_num == all_target[2].goal or self.success_num == all_target[3].goal or self.success_num == all_target[4].goal then                
        local box_list = model:getSevenGoalBoxList()
        for i=1,4 do
            if self.success_num == all_target[i].goal then
                if box_list[i].status == 0 then
                    box_list[i].status = 1
                end
            end
        end
        self:updateTaskList(box_list)
    end

    self:redPointTabDayList(data.day_type, true)
end

function ActionSevenGoalWindow:sevenGoalRemainTime()
    self.goalEndTime = self.goalEndTime - 1
    if self.goalEndTime <= 0 then
        doStopAllActions(self.sevenGoalTime)
        self.sevenGoalTime:setString("00:00:00")
    end
    self.sevenGoalTime:setString(TimeTool.GetTimeFormat(self.goalEndTime))
end

--未开启的天数灰化      传入当前的天数
function ActionSevenGoalWindow:noArriveDayGray(day)
    day = day or 1
    if self.cur_index then
        self.currentDay = day
        self:selectByBtn( self.cur_index )
    end

    for i,v in pairs(self.sheet_list) do
        if i==day then
            v:setTouchEnabled(false)
            v.select:setVisible(true)
        else
            v:setTouchEnabled(true)
            v.select:setVisible(false)
        end

        if i <= self.initCurrentDay then
            v.closed_bg:setVisible(false)
            v.opened_bg:setVisible(true)
        else
            v.closed_bg:setVisible(true)
            v.opened_bg:setVisible(false)
        end
    end

    --local number_period = model:getSevenGoldPeriod()
    --if number_period == 7 then
    --    number_period = 4
    --end
    --local str_res = string.format("seven_goals/%d",number_period)
    --for i=1, 7 do
    --    delayRun(self.layer_tab,i / display.DEFAULT_FPS,function ()
    --        if i <= self.initCurrentDay then
    --            if i == day then
    --                local res = PathTool.getPlistImgForDownLoad(str_res,"seven_goals_1_2")
    --                if not self.load_touch_day[day] then
    --                    if self.touchTotleDay[i].rewardImage then
    --                        self.load_touch_day[day] = loadSpriteTextureFromCDN(self.touchTotleDay[day].rewardImage, res, ResourcesType.single, self.load_touch_day[day])
    --                    end
    --                end
    --                if self.load_touch_day[day] then
    --                    if self.touchTotleDay[i].rewardImage then
    --                        loadSpriteTexture(self.touchTotleDay[day].rewardImage,res, LOADTEXT_TYPE)
    --                    end
    --                end
    --            else
    --                local res = PathTool.getPlistImgForDownLoad(str_res,"seven_goals_1_1")
    --                if not self.load_touch_day[i] then
    --                    if self.touchTotleDay[i].rewardImage then
    --                        self.load_touch_day[i] = loadSpriteTextureFromCDN(self.touchTotleDay[i].rewardImage, res, ResourcesType.single, self.load_touch_day[i])
    --                    end
    --                end
    --                if self.load_touch_day[i] then
    --                    if self.touchTotleDay[i].rewardImage then
    --                        loadSpriteTexture(self.touchTotleDay[i].rewardImage,res, LOADTEXT_TYPE)
    --                    end
    --                end
    --            end
    --        else
    --            if self.touchTotleDay[i] then
    --                setChildUnEnabled(true, self.touchTotleDay[i].btn,cc.c4b(0xD3,0xD3,0xD3,0xff))
    --            end
    --            local res = PathTool.getPlistImgForDownLoad(str_res,"seven_goals_1_1")
    --            if not self.load_touch_day[i] then
    --                if self.touchTotleDay[i].rewardImage then
    --                    self.load_touch_day[i] = loadSpriteTextureFromCDN(self.touchTotleDay[i].rewardImage, res, ResourcesType.single, self.load_touch_day[i])
    --                end
    --            end
    --            if self.load_touch_day[i] then
    --                if self.touchTotleDay[i].rewardImage then
    --                    loadSpriteTexture(self.touchTotleDay[i].rewardImage,res, LOADTEXT_TYPE)
    --                end
    --            end
    --        end
    --    end)
    --end
end

--逆向排序
function ActionSevenGoalWindow:reverseTable(tab)
    if tab == nil then return {} end
    local tmp = {}
    for i = 1, #tab do
        tmp[i] = table.remove(tab)
    end
    return tmp
end
function ActionSevenGoalWindow:sortFunc(data)
    local tempsort = {
        [0] = 2,  -- 0 未领取放中间
        [1] = 1,  -- 1 可领取放前面
        [2] = 3,  -- 2 已领取放最后
    }
    local function sortFunc( objA, objB )
        if objA.status ~= objB.status then
            if tempsort[objA.status] and tempsort[objB.status] then
                return tempsort[objA.status] < tempsort[objB.status]
            else
                return false
            end
        else
            return objA.goal_id < objB.goal_id
        end
    end
    table.sort(data, sortFunc)
    return data
end

--获取名字
function ActionSevenGoalWindow:getTabName(day)
    local grow = model:getWalfareGrowUpData(day)
    local gift = model:getWelfareGiftData(day)
    local name1,name2 = "",""
    if next(grow) ~= nil and grow[1].type_name then
        name1 = grow[1].type_name
    end
    if next(gift) ~= nil and gift[1].type_name then
        name2 = gift[1].type_name
    end
    return name1,name2
end

--主切换按钮
function ActionSevenGoalWindow:selectByBtn( index )
    index = index or 1
    self.cur_index = index

    for i,v in pairs(self.tab_btn_list) do
        if i == index then
            v:setTouchEnabled(false)
            v.normal:setVisible(false)
            v.select:setVisible(true)
        else
            v:setTouchEnabled(true)
            v.normal:setVisible(true)
            v.select:setVisible(false)
        end
    end

    --for i,v in pairs(self.sheet_list) do
    --    if i==index then
    --        v.select:setVisible(true)
    --    else
    --        v.select:setVisible(false)
    --    end
    --
    --    if i <= self.initCurrentDay then
    --        v.closed_bg:setVisible(false)
    --        v.opened_bg:setVisible(true)
    --    else
    --        v.closed_bg:setVisible(true)
    --        v.opened_bg:setVisible(false)
    --    end
    --end

    --if self.cur_select ~= nil then
    --    self.cur_select.select:setVisible(false)
    --    self.cur_select.title:setTextColor(cc.c4b(0xEE, 0xD1, 0xAF, 0xff))
    --    self.cur_select.title:enableOutline(cc.c4b(0x53, 0x3D, 0x32, 0xff), 2)
    --end
    --self.cur_index = index
    --self.cur_select = self.btn_list[self.cur_index]
    --if self.cur_select ~= nil then
    --    self.cur_select.select:setVisible(true)
    --    self.cur_select.title:disableEffect(cc.LabelEffect.OUTLINE)
    --    self.cur_select.title:setTextColor(cc.c4b(0x64, 0x32, 0x23, 0xff))
    --end
    --
    self:redPointTabDayList(self.currentDay)

    local walfare_data = {}
    local serve_list = {}
    local sort_list = {}

    if self.cur_index == 1 then
        walfare_data = model:getWalfareData(self.currentDay)
        serve_list = model:getSevenGoalWelfareList(self.currentDay)
    elseif self.cur_index == 2 then
        walfare_data = model:getWalfareGrowUpData(self.currentDay)
        serve_list = model:getServerGrowListData(self.currentDay)
    elseif self.cur_index == 3 then
        walfare_data = model:getWelfareGiftData(self.currentDay)
        serve_list = model:getServerGiftListData(self.currentDay)
    elseif self.cur_index == 4 then
        walfare_data = model:getWelfareHalfData(self.currentDay)
        serve_list = model:getHalfGiftList(self.currentDay)
    end

    local name1,name2 = self:getTabName(self.currentDay)
    self.tab_btn_list[2].normal_label:setString(name1)
    self.tab_btn_list[2].select_label:setString(name1)
    self.tab_btn_list[3].normal_label:setString(name2)
    self.tab_btn_list[3].select_label:setString(name2)

    self.tab_btn_list[2].normal_label:setFontSize(28)
    self.tab_btn_list[2].select_label:setFontSize(28)
    if self.tab_btn_list[2].normal_label:getContentSize().width > 200 then
        for k=1,15 do
            self.tab_btn_list[2].normal_label:setFontSize(28-k)
            self.tab_btn_list[2].select_label:setFontSize(28-k)
            if self.tab_btn_list[2].normal_label:getContentSize().width <= 200 then
                break
            end
        end
    end
    self.tab_btn_list[3].normal_label:setFontSize(28)
    self.tab_btn_list[3].select_label:setFontSize(28)
    if self.tab_btn_list[3].normal_label:getContentSize().width > 200 then
        for k=1,15 do
            self.tab_btn_list[3].normal_label:setFontSize(28-k)
            self.tab_btn_list[3].select_label:setFontSize(28-k)
            if self.tab_btn_list[3].normal_label:getContentSize().width <= 200 then
                break
            end
        end
    end

    --self.btn_list[2].title:setString(name1)
    --self.btn_list[3].title:setString(name2)

    if self.cur_index == 4 then
        table.sort( serve_list, function(a,b)
            return a.status < b.status
        end )
        for i,v in ipairs(serve_list) do
            for k,val in ipairs(walfare_data) do
                if v.day == val.id then
                    table_insert(sort_list, val)
                end
            end
        end
    else
        serve_list = self:reverseTable(deepCopy(serve_list))
        serve_list = self:sortFunc(serve_list)
        for i,v in ipairs(serve_list) do
            for k,val in ipairs(walfare_data) do
                if v.goal_id == val.goal_id then
                    table_insert(sort_list, val)
                end
            end
        end
    end
    walfare_data = sort_list

    local tab = {}
    tab.list = serve_list
    tab.type = self.cur_index
    tab.day = self.currentDay
    tab.init_cur_day = self.initCurrentDay
    if self.cur_index == 4 then
        self.item_scrollview_walfare2:setData(walfare_data, nil, nil, tab)
        self.item_scrollview_walfare:setVisible(false)
        self.item_scrollview_walfare2:setVisible(true)
    else
        self.item_scrollview_walfare:setData(walfare_data, nil, nil, tab)
        self.item_scrollview_walfare:setVisible(true)
        self.item_scrollview_walfare2:setVisible(false)
    end
end

--初始化天数的红点
function ActionSevenGoalWindow:initRedPointDay(day)
    if day < 1 or day > 7 then
        return {}
    end
    local status = {}
    for i=1, day do
        status[i] = false
        local welfare_status = model:getRedPointWelfareStatus(i)
        local grow_status = model:getRedPointGrowStatus(i)
        local gift_status = model:getRedPointGiftStatus(i)
        local half_status = model:getRedPointHalfStatus(i)
        
        local total_status = false
        total_status = welfare_status or grow_status or gift_status or half_status
        status[i] = total_status
    end
    return status
end
--实时更新 天数 红点
function ActionSevenGoalWindow:redPointTabDayList(day, _type)
    if self.currentDay < 1 or self.currentDay > 7 then
        return
    end

    local welfare_status = model:getRedPointWelfareStatus(day)
    if welfare_status == true and self.tab_btn_list[1].red_point_spine == nil then
        self.tab_btn_list[1].red_point_spine = PathTool.gw_createRedpointSpine()
        self.tab_btn_list[1].red_point:addChild(self.tab_btn_list[1].red_point_spine)
    end
    self.tab_btn_list[1].red_point:setVisible(welfare_status)
    --if self.btn_list[1].red_point then
    --    self.btn_list[1].red_point:setVisible(welfare_status)
    --end

    local grow_status = model:getRedPointGrowStatus(day)
    if grow_status == true and self.tab_btn_list[2].red_point_spine == nil then
        self.tab_btn_list[2].red_point_spine = PathTool.gw_createRedpointSpine()
        self.tab_btn_list[2].red_point:addChild(self.tab_btn_list[2].red_point_spine)
    end
    self.tab_btn_list[2].red_point:setVisible(grow_status)
    --if self.btn_list[2].red_point then
    --    self.btn_list[2].red_point:setVisible(grow_status)
    --end

    local gift_status = model:getRedPointGiftStatus(day)
    if gift_status == true and self.tab_btn_list[3].red_point_spine == nil then
        self.tab_btn_list[3].red_point_spine = PathTool.gw_createRedpointSpine()
        self.tab_btn_list[3].red_point:addChild(self.tab_btn_list[3].red_point_spine)
    end
    self.tab_btn_list[3].red_point:setVisible(gift_status)
    --if self.btn_list[3].red_point then
    --    self.btn_list[3].red_point:setVisible(gift_status)
    --end

    local half_status = model:getRedPointHalfStatus(day)
    if half_status == true and self.tab_btn_list[4].red_point_spine == nil then
        self.tab_btn_list[4].red_point_spine = PathTool.gw_createRedpointSpine()
        self.tab_btn_list[4].red_point:addChild(self.tab_btn_list[4].red_point_spine)
    end
    self.tab_btn_list[4].red_point:setVisible(half_status)
    --if self.btn_list[4].red_point then
    --    self.btn_list[4].red_point:setVisible(half_status)
    --end

    if _type then
        local total_status = false
        total_status = welfare_status or grow_status or gift_status or half_status
        if total_status == true and self.sheet_list[day].red_point_spine == nil then
            self.sheet_list[day].red_point_spine = PathTool.gw_createRedpointSpine()
            self.sheet_list[day].red_point:addChild(self.sheet_list[day].red_point_spine)
        end
        self.sheet_list[day].red_point:setVisible(total_status)
        --if self.touchTotleDay[day].red_point then
        --    self.touchTotleDay[day].red_point:setVisible(total_status)
        --end

        --场景天数红点
        local initDayRed = self:initRedPointDay(self.currentDay)
        local red_point = false
        for i,v in ipairs(initDayRed) do
            if v and v == true then
                red_point = true
                break
            end
        end
        --宝箱
        local boxRed = false
        for i=1,3 do
            local status = model:getRedPointBoxStatus(i)
            if status == true then
                boxRed = true
                break
            end
        end

        local icon_id = MainuiConst.icon.seven_goal3
        if model:getSevenGoldPeriod() == 1 then
            icon_id = MainuiConst.icon.seven_goal
        elseif model:getSevenGoldPeriod() == 2 then
            icon_id = MainuiConst.icon.seven_goal1
        elseif model:getSevenGoldPeriod() == 3 then
            icon_id = MainuiConst.icon.seven_goal2
        elseif model:getSevenGoldPeriod() == 7 then
            icon_id = MainuiConst.icon.seven_goal4
        end

        GlobalEvent:getInstance():Fire(ActionEvent.GW_UPDATE_SEVENT_GET_RED_POINT, red_point or boxRed)
        --MainuiController:getInstance():setFunctionTipsStatus(icon_id, red_point or boxRed)
    end
end
--刷新宝箱
function ActionSevenGoalWindow:updateTaskList(data)
    local all_target = model:getBoxRewardData()
    for i=1, 4 do
        local item = self.box_infos_box_list[i]
        if item == nil then break end

        --local icon_res = "NumberBox1"
        local is_open = false
        local finished = false
        local red_point = false
        if next(data) ~= nil and data[i] then
            if data[i] and data[i].status == 0 then--未达成

            elseif data[i] and data[i].status == 1 then--可领取
                is_open = true
                red_point = true
            elseif data[i] and data[i].status == 2 then--已领取
                is_open = true
                finished = true
            end
        end
        --if finished == true then
        --    if i == 1 then
        --        icon_res = "NumberBox20"
        --    elseif i == 2 then
        --        icon_res = "NumberBox4"
        --    elseif i == 3 then
        --        icon_res = "NumberBox6"
        --    else--if i == 4 then
        --        icon_res = "NumberBox8"
        --    end
        --else
        --    if i == 1 then
        --        icon_res = "NumberBox10"
        --    elseif i == 2 then
        --        icon_res = "NumberBox3"
        --    elseif i == 3 then
        --        icon_res = "NumberBox5"
        --    else--if i == 4 then
        --        icon_res = "NumberBox7"
        --    end
        --end

        if red_point == true and item.red_point_spine == nil then
            item.red_point_spine = PathTool.gw_createRedpointSpine()
            item.red_point:addChild(item.red_point_spine)
        end
        item.red_point:setVisible(red_point)
        --loadSpriteTexture(item.icon, PathTool.getResFrame("gw_task", icon_res), LOADTEXT_TYPE_PLIST)
        --setChildUnEnabled(not is_open, item.icon)

        local item_bid = nil
        local item_num = nil
        if all_target[i] ~= nil and all_target[i].award ~= nil and all_target[i].award[1] ~= nil then
            item_bid = all_target[i].award[1][1]
            item_num = all_target[i].award[1][2]
        end

        if item_bid ~= nil and item_num ~= nil then
            if item.gw_item == nil then
                item.gw_item = GW_GoodsItem3.new(false, true, false, 1, false, true)
                --item.gw_item:setDefaultTip(false,false)
                item.gw_item:gw_showShadow()
                item.gw_item:setPosition(cc.p(0, 0))
                item.item_node:addChild(item.gw_item)
            end

            item.gw_item:setBaseData(item_bid, item_num)
            item.item_node:setVisible(true)
        else
            Debug.error("宝箱奖励为空！！！")
            item.item_node:setVisible(false)
        end

        if item.gw_item ~= nil then
            if finished == true then
                item.gw_item:gw_showGetted(true)
            else
                item.gw_item:gw_showGetted(false)
            end

            if finished == true or is_open == false then
                item.gw_item:gw_showCanGet(false)
                item.gw_item:setTouchEnabled(true)
                item.gw_item:setDefaultTip(true)
            else
                item.gw_item:gw_showCanGet(true)
                item.gw_item:setTouchEnabled(false)
                item.gw_item:setDefaultTip(false)
            end
        end

        if finished == true or is_open == false then
            item.btn:setVisible(false)
        else
            item.btn:setVisible(true)
        end


        setChildUnEnabled(not is_open, item.item_node)



        --local action = PlayerAction.action_1
        --self.box_list_layer[i].redpoint:setVisible(false)
        --
        --if next(data) ~= nil and data[i] then
        --    if data[i] and data[i].status == 0 then
        --        action = PlayerAction.action_1
        --    elseif data[i] and data[i].status == 1 then
        --        action = PlayerAction.action_2
        --        self.box_list_layer[i].redpoint:setVisible(true)
        --    elseif data[i] and data[i].status == 2 then
        --        action = PlayerAction.action_3
        --    end
        --end
        --
        --if self.play_effect[i] then
        --    self.play_effect[i]:clearTracks()
        --    self.play_effect[i]:removeFromParent()
        --    self.play_effect[i] = nil
        --end
        --if not tolua.isnull(self.box_list_layer[i]) and self.play_effect[i] == nil then
        --    local res_id = PathTool.getEffectRes(self.award_list[i])
        --    self.play_effect[i] = createEffectSpine(res_id, cc.p(self.box_list_layer[i]:getContentSize().width * 0.5, 0), cc.p(0, 0), true, action)
        --    self.box_list_layer[i]:addChild(self.play_effect[i])
        --end
    end
end

function ActionSevenGoalWindow:setSemgentPercent(num)
    local segmeent = 25
    local percent = 1

    local all_target = model:getBoxRewardData()
    if all_target[1] == nil or all_target[2] == nil or all_target[3] == nil or all_target[4] == nil then return 0 end

    if num <= all_target[1].goal then
        return num / all_target[1].goal * segmeent
    elseif num > all_target[1].goal and num <= all_target[2].goal then
        percent = 2
    elseif num > all_target[2].goal and num <= all_target[3].goal then
        percent = 3
    elseif num > all_target[3].goal and num <= all_target[4].goal then
        percent = 4
    else
        return 100
    end
    local adv = all_target[percent].goal - all_target[percent-1].goal
    local count = num - all_target[percent-1].goal
    local percent_num = segmeent*(percent - 1) + ( count / adv ) * segmeent
    return percent_num
end


function ActionSevenGoalWindow:close_callback()
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.girl_icon_load then
        self.girl_icon_load:DeleteMe()
        self.girl_icon_load = nil
    end

    if self.sheet_list ~= nil then
        for i,v in pairs(self.sheet_list) do
            if v.red_point_spine ~= nil then
                v.red_point_spine:clearTracks()
                v.red_point_spine:removeFromParent()
                v.red_point_spine = nil
            end
        end

        self.sheet_list = nil
    end
    if self.tab_btn_list ~= nil then
        for i,v in pairs(self.tab_btn_list) do
            if v.red_point_spine ~= nil then
                v.red_point_spine:clearTracks()
                v.red_point_spine:removeFromParent()
                v.red_point_spine = nil
            end
        end

        self.tab_btn_list = nil
    end
    if self.box_infos_box_list ~= nil then
        for i,v in pairs(self.box_infos_box_list) do
            if v.red_point_spine ~= nil then
                v.red_point_spine:clearTracks()
                v.red_point_spine:removeFromParent()
                v.red_point_spine = nil
            end
            if v.gw_item ~= nil then
                v.gw_item:DeleteMe()
                v.gw_item = nil
            end
        end

        self.box_infos_box_list = nil
    end

    if self.role_update_event ~= nil then
        role_vo:UnBind(self.role_update_event)
        self.role_update_event = nil
    end

    self.top_num_wealth_list = nil

    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end

    --doStopAllActions(self.layer_tab)
    --self.cur_select = nil
    --if self.play_effect and next(self.play_effect or {}) ~= nil then
    --    for i=1, 4 do
    --        if self.play_effect[i] then
    --            self.play_effect[i]:clearTracks()
    --            self.play_effect[i]:removeFromParent()
    --            self.play_effect[i] = nil
    --        end
    --    end
    --end
    --
    --if self.item_load then
    --    self.item_load:DeleteMe()
    --end
    --self.item_load = nil
    --if self.load_round_finish then
    --    self.load_round_finish:DeleteMe()
    --end
    --self.load_round_finish = nil
    --if self.load_day_title then
    --    self.load_day_title:DeleteMe()
    --end
    --self.load_day_title = nil
    --
    --for i,v in pairs(self.load_touch_day) do
    --    if v then
    --        v:DeleteMe()
    --        v = nil
    --    end
    --end
    --
    --self.play_effect = {}
    if self.item_scrollview_walfare then
        self.item_scrollview_walfare:DeleteMe()
        self.item_scrollview_walfare = nil
    end
    if self.item_scrollview_walfare2 then
        self.item_scrollview_walfare2:DeleteMe()
        self.item_scrollview_walfare2 = nil
    end
    doStopAllActions(self.sevenGoalTime)
    controller:openSevenGoalView(false)
end

--刷新上方货币
function ActionSevenGoalWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    if self.top_num_wealth_list[3] ~= nil then
        local key = "hero_exp"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[3].btn:setVisible(true)
    end
end

--更新点金红点
function ActionSevenGoalWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and role_vo and red_lev_min and red_lev_min.val <= role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end

--子项
ActionSevenGoalItem = class("ActionSevenGoalItem", function()
    return ccui.Widget:create()
end)

function ActionSevenGoalItem:ctor()
    self.goods_list = {}
    self:configUI()
    self:register_event()
end

function ActionSevenGoalItem:configUI( )
    self.size = cc.size(726,112)
    self:setTouchEnabled(true)
    self:setContentSize(self.size)

    local csbPath = PathTool.getTargetCSB("action/action_seven_goal_item")
    self.root_wnd = cc.CSLoader:createNode(csbPath)
    self:addChild(self.root_wnd)

    self.main_container = self.root_wnd:getChildByName("main_container")

    self.type1 = self.main_container:getChildByName("type1")
    self.type1:setVisible(false)
    self.type1_desc = self.type1:getChildByName("desc")
    self.type1_bar = self.type1:getChildByName("bar")
    self.type1_bar:setScale9Enabled(true)
    self.type1_bar_label = self.type1:getChildByName("bar_label")
    self.type1_goto_btn = self.type1:getChildByName("goto_btn")
    self.type1_goto_btn_label = self.type1_goto_btn:getChildByName("label")
    self.type1_goto_btn_label:setString(UI_TI18N(42012))
    self.type1_finish_btn = self.type1:getChildByName("finish_btn")
    self.type1_finish_btn:getChildByName("label"):setString(UI_TI18N(42013))
    self.type2 = self.main_container:getChildByName("type2")
    self.type2:setVisible(false)
    self.type2_desc = self.type2:getChildByName("desc")
    self.type2_get_btn = self.type2:getChildByName("get_btn")
    self.type2_get_btn:getChildByName("label"):setString(UI_TI18N(42014))
    self.item_node = self.main_container:getChildByName("item_node")

    --self.goods_con = self.main_container:getChildByName("goods_con")
    --self.has_bg = self.main_container:getChildByName("has_bg")
    --self.has_bg:setVisible(false)
    --
    --self.textGet = self.main_container:getChildByName("textGet")
    --self.btn_get = self.main_container:getChildByName("btn_get")
    --self.btn_get:setTitleText(TI18N("领取"))
    --local btn_get_label = self.btn_get:getTitleRenderer()
    --if btn_get_label ~= nil then
    --    btn_get_label:enableOutline(Config.ColorData.data_color4[277], 2)
    --end
    --self.btn_get:setVisible(false)
    --
    --self.btn_goto = self.main_container:getChildByName("btn_goto")
    --self.btn_goto:setTitleText(TI18N("前往"))
    --self.btn_goto_label = self.btn_goto:getTitleRenderer()
    --if self.btn_goto_label ~= nil then
    --    self.btn_goto_label:enableOutline(Config.ColorData.data_color4[278], 2)
    --end
    --self.btn_goto:setVisible(false)
    --
    --self.half_panel = self.main_container:getChildByName("half_panel")
    --self.half_panel:getChildByName("Text_1"):setString(TI18N("原价:"))
    --self.price_1 = self.half_panel:getChildByName("price_1")
    --self.btn_buy = self.half_panel:getChildByName("btn_buy")
    --self.price_2 = self.btn_buy:getChildByName("price_2")
    --self.half_panel:setVisible(false)
    --
    --self.title_txt = self.main_container:getChildByName("title_txt")
end

function ActionSevenGoalItem:setExtendData(tab)
    self.serve_list = tab.list
    self.type = tab.type
    self.cur_day = tab.day
    self.init_cur_day = tab.init_cur_day
end

function ActionSevenGoalItem:setData( data )
    if not data or next(data) == nil then return end
    self.data = data
    if data.desc then
        self.type1_desc:setString(data.desc)
        self.type1_desc:setFontSize(28)
        if self.type1_desc:getContentSize().width > 300 then
            for i=1,10 do
                self.type1_desc:setFontSize(28-i)
                if self.type1_desc:getContentSize().width <= 300 then
                    break
                end
            end
        end

        self.type2_desc:setString(data.desc)
        self.type2_desc:setFontSize(28)
        if self.type2_desc:getContentSize().width > 230 then
            for i=1,10 do
                self.type2_desc:setFontSize(28-i)
                if self.type2_desc:getContentSize().width <= 230 then
                    break
                end
            end
        end
        --self.title_txt:setString(data.desc)
    end

    for i,v in pairs(self.goods_list) do
        v:setVisible(false)
    end
    for i=1, #data.award1 do
        local item = self.goods_list[i]
        if item == nil then
            item = GW_GoodsItem3.new(true,true)
            --item:setDefaultTip(true)
            item:setScale(0.65)
            item:setAnchorPoint(0.5,0.5)
            item:setPosition(-(i-1)*95,0)
            item:setTouchEnabled(true)
            item:setSwallowTouches(false)
            self.item_node:addChild(item)
            self.goods_list[i] = item
        end

        item:setVisible(true)
        item:setBaseData(data.award1[i][1], data.award1[i][2])
        item:setDefaultTip()
    end

    if self.type == 1 then
        local val = self.serve_list[self.data._index]
        if val then
            local value = val.value or 0
            if self.cur_day > self.init_cur_day then
                value = 0
            end
            local target_val = val.target_val or 0
            local str = string.format("%d/%d",value,target_val)
            self.type1_bar_label:setString(str)
            if target_val <= 0 then
                self.type1_bar:setPercent(100)
            else
                self.type1_bar:setPercent(100*value/target_val)
            end
        end
    elseif self.type == 2 or self.type == 3 then
        if self.serve_list[self.data._index].progress and self.serve_list[self.data._index].progress[1] then
            local val = self.serve_list[self.data._index].progress[1]
            if val then
                local value = val.value or 0
                if self.cur_day > self.init_cur_day then
                    value = 0
                end
                local target_val = val.target_val or 0
                local str = string.format("%d/%d",value,target_val)
                self.type1_bar_label:setString(str)
                if target_val <= 0 then
                    self.type1_bar:setPercent(100)
                else
                    self.type1_bar:setPercent(100*value/target_val)
                end
            end
        end
    elseif self.type == 4 then        
        --self.btn_goto:setVisible(false)
        --self.btn_get:setVisible(false)
        --self.has_bg:setVisible(false)
        --
        --self.price_1:setString(data.price1)
        --self.price_2:setString(data.price2)
        --if self.serve_list[self.data._index].status == 0 then
        --    self.half_panel:setVisible(true)
        --    self.has_bg:setVisible(false)
        --    self.textGet:setString(TI18N("剩余: 1"))
        --else
        --    self.half_panel:setVisible(false)
        --    self.has_bg:setVisible(true)
        --    self.textGet:setString(TI18N("剩余: 0"))
        --end
    end

    if self.type ~= 4 then
        if self.cur_day > self.init_cur_day then
            self.type1_goto_btn:setTouchEnabled(false)
            setChildUnEnabled(true, self.type1_goto_btn)
            self.type1_goto_btn_label:disableEffect(cc.LabelEffect.OUTLINE)
            --self.type1_goto_btn_label:enableOutline(Config.ColorData.data_color4[2], 2)

            self.type1_goto_btn:setVisible(true)
            self.type1_finish_btn:setVisible(false)
            self.type1:setVisible(true)
            self.type2:setVisible(false)
        else
            if self.serve_list[self.data._index].status == 1 then--可领取
                self.type1:setVisible(false)
                self.type2:setVisible(true)
            else
                if self.serve_list[self.data._index].status == 0 then--未达成
                    self.type1_goto_btn:setTouchEnabled(true)
                    setChildUnEnabled(false, self.type1_goto_btn)
                    self.type1_goto_btn_label:enableOutline(cc.c4b(0x0b,0x7e,0xb3,0xff), 2)
                    self.type1_goto_btn:setVisible(true)
                    self.type1_finish_btn:setVisible(false)
                else--已完成
                    self.type1_goto_btn:setVisible(false)
                    self.type1_finish_btn:setVisible(true)
                end
                self.type1:setVisible(true)
                self.type2:setVisible(false)
            end
        end
        --self.half_panel:setVisible(false)
        --self.btn_goto:setVisible(self.serve_list[self.data._index].status == 0)
        --self.btn_get:setVisible(self.serve_list[self.data._index].status == 1)
        --self.has_bg:setVisible(self.serve_list[self.data._index].status == 2)
        --if self.init_cur_day and self.cur_day > self.init_cur_day then
        --    self.btn_goto:setVisible(true)
        --    self.btn_goto:setTitleText(TI18N("未解锁"))
        --    setChildUnEnabled(true, self.btn_goto)
        --    self.btn_goto_label:disableEffect(cc.LabelEffect.OUTLINE)
        --    self.btn_goto:setTouchEnabled(false)
        --    self.btn_get:setVisible(false)
        --    self.has_bg:setVisible(false)
        --else
        --    setChildUnEnabled(false, self.btn_goto)
        --    self.btn_goto_label:enableOutline(Config.ColorData.data_color4[278], 2)
        --    self.btn_goto:setTouchEnabled(true)
        --end
    end
end

function ActionSevenGoalItem:register_event( )
    registerButtonEventListener(self.type2_get_btn, function()
        ActionController:getInstance():cs13602(self.type, self.cur_day, self.serve_list[self.data._index].goal_id, self.data._index)
    end,true, 1)

    registerButtonEventListener(self.type1_goto_btn, function()
        StrongerController:getInstance():clickCallBack(self.data.show_icon)
        ActionController:getInstance():openSevenGoalView(false)
    end,true, 1)

    --registerButtonEventListener(self.btn_buy, function()
    --    ActionController:getInstance():cs13602(self.type, self.cur_day, self.data.id, self.data._index)
    --end,true, 1)
end

function ActionSevenGoalItem:DeleteMe()
    --if self.item_scrollview then
    --    self.item_scrollview:DeleteMe()
    --    self.item_scrollview = nil
    --end
    if self.goods_list and next(self.goods_list or {}) ~= nil then
        for i, v in ipairs(self.goods_list) do
            if v.DeleteMe then
                v:DeleteMe()
            end
        end
    end
    self:removeAllChildren()
    self:removeFromParent()
end


--子项2
ActionSevenGoalItem2 = class("ActionSevenGoalItem2", function()
    return ccui.Widget:create()
end)

function ActionSevenGoalItem2:ctor()
    self.goods_list = {}
    self:configUI()
    self:register_event()
end

function ActionSevenGoalItem2:configUI( )
    self.size = cc.size(726,144)
    self:setTouchEnabled(true)
    self:setContentSize(self.size)

    local csbPath = PathTool.getTargetCSB("action/gw_action_seven_goal_item2")
    self.root_wnd = cc.CSLoader:createNode(csbPath)
    self:addChild(self.root_wnd)

    self.main_container = self.root_wnd:getChildByName("main_container")

    self.bg = self.main_container:getChildByName("bg")
    self.original_cost = self.main_container:getChildByName("original_cost")
    loadSpriteTexture(self.original_cost, PathTool.getItemRes(3), LOADTEXT_TYPE)
    self.original_label = self.main_container:getChildByName("original_label")
    self.line = self.main_container:getChildByName("line")
    self.name = self.main_container:getChildByName("name")
    self.finish_btn = self.main_container:getChildByName("finish_btn")
    local label = self.finish_btn:getChildByName("label")
    label:setString(UI_TI18N(42015))
    label:setFontSize(28)
    if label:getContentSize().width > 170 then
        for i=1,10 do
            label:setFontSize(28-i)
            if label:getContentSize().width <= 170 then
                break
            end
        end
    end
    self.buy_btn = self.main_container:getChildByName("buy_btn")
    self.buy_btn_label_node = self.buy_btn:getChildByName("label_node")
    self.buy_btn_label = createRichLabel(28, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(0, 0))
    self.buy_btn_label_node:addChild(self.buy_btn_label)
    self.less_count_bg = self.main_container:getChildByName("less_count_bg")
    self.less_count_bg_label = self.less_count_bg:getChildByName("label")
    self.item_node = self.main_container:getChildByName("item_node")

    --self.goods_con = self.main_container:getChildByName("goods_con")
    --self.has_bg = self.main_container:getChildByName("has_bg")
    --self.has_bg:setVisible(false)
    --
    --self.textGet = self.main_container:getChildByName("textGet")
    --self.btn_get = self.main_container:getChildByName("btn_get")
    --self.btn_get:setTitleText(TI18N("领取"))
    --local btn_get_label = self.btn_get:getTitleRenderer()
    --if btn_get_label ~= nil then
    --    btn_get_label:enableOutline(Config.ColorData.data_color4[277], 2)
    --end
    --self.btn_get:setVisible(false)
    --
    --self.btn_goto = self.main_container:getChildByName("btn_goto")
    --self.btn_goto:setTitleText(TI18N("前往"))
    --self.btn_goto_label = self.btn_goto:getTitleRenderer()
    --if self.btn_goto_label ~= nil then
    --    self.btn_goto_label:enableOutline(Config.ColorData.data_color4[278], 2)
    --end
    --self.btn_goto:setVisible(false)
    --
    --self.half_panel = self.main_container:getChildByName("half_panel")
    --self.half_panel:getChildByName("Text_1"):setString(TI18N("原价:"))
    --self.price_1 = self.half_panel:getChildByName("price_1")
    --self.btn_buy = self.half_panel:getChildByName("btn_buy")
    --self.price_2 = self.btn_buy:getChildByName("price_2")
    --self.half_panel:setVisible(false)
    --
    --self.title_txt = self.main_container:getChildByName("title_txt")
end

function ActionSevenGoalItem2:setExtendData(tab)
    self.serve_list = tab.list
    self.type = tab.type
    self.cur_day = tab.day
    self.init_cur_day = tab.init_cur_day
end

function ActionSevenGoalItem2:setData( data )
    if not data or next(data) == nil then return end
    self.data = data
    if data.desc then
        self.name:setString(data.desc)
        self.name:setFontSize(26)
        if self.name:getContentSize().width > 236 then
            for i=1,10 do
                self.name:setFontSize(26 - i)
                if self.name:getContentSize().width <= 236 then
                    break
                end
            end
        end
        --self.type1_desc:setString(data.desc)
        --self.type2_desc:setString(data.desc)
        --self.title_txt:setString(data.desc)
    end

    for i,v in pairs(self.goods_list) do
        v:setVisible(false)
    end
    for i=1, #data.award1 do
        local item = self.goods_list[i]
        if item == nil then
            item = GW_GoodsItem3.new(true,true)
            --item:setDefaultTip(true)
            item:setScale(0.65)
            item:setAnchorPoint(0.5,0.5)
            item:setPosition(-(i-1)*95,0)
            item:setTouchEnabled(true)
            item:setSwallowTouches(false)
            self.item_node:addChild(item)
            self.goods_list[i] = item
        end

        item:setVisible(true)
        item:setBaseData(data.award1[i][1], data.award1[i][2])
        item:setDefaultTip()
    end

    if self.type == 1 then
        --local val = self.serve_list[self.data._index]
        --if val then
        --    local value = val.value or 0
        --    local target_val = val.target_val or 0
        --    local str = string.format("%d/%d",value,target_val)
        --    self.type1_bar_label:setString(str)
        --    if target_val <= 0 then
        --        self.type1_bar:setPercent(100)
        --    else
        --        self.type1_bar:setPercent(100*value/target_val)
        --    end
        --end
    elseif self.type == 2 or self.type == 3 then
        --if self.serve_list[self.data._index].progress and self.serve_list[self.data._index].progress[1] then
        --    local val = self.serve_list[self.data._index].progress[1]
        --    if val then
        --        local value = val.value or 0
        --        local target_val = val.target_val or 0
        --        local str = string.format("%d/%d",value,target_val)
        --        self.type1_bar_label:setString(str)
        --        if target_val <= 0 then
        --            self.type1_bar:setPercent(100)
        --        else
        --            self.type1_bar:setPercent(100*value/target_val)
        --        end
        --    end
        --end
    elseif self.type == 4 then
        local buy_btn_str = string.format("<img src='%s' scale=0.35 /><div outline=2,#915013>%d</div>", PathTool.getItemRes(3), data.price2)
        if self.cur_day > self.init_cur_day then
            buy_btn_str = string.format("<img src='%s' scale=0.35 />%d", PathTool.getItemRes(3), data.price2)
        end
        self.buy_btn_label:setString(buy_btn_str)
        self.original_label:setString(data.price1)
        self.original_cost:setPositionX(self.original_label:getPositionX() - self.original_label:getContentSize().width)
        self.line:setContentSize(cc.size(self.original_label:getContentSize().width - 2, 2))
        if self.serve_list[self.data._index].status == 0 then
            self.finish_btn:setVisible(false)
            self.buy_btn:setVisible(true)

            self.less_count_bg_label:setString(UI_TI18N(42016))
        else
            self.finish_btn:setVisible(true)
            self.buy_btn:setVisible(false)

            self.less_count_bg_label:setString(UI_TI18N(42017))
        end

        if self.cur_day > self.init_cur_day then
            self.buy_btn:setTouchEnabled(false)
            setChildUnEnabled(true, self.buy_btn)
        else
            self.buy_btn:setTouchEnabled(true)
            setChildUnEnabled(false, self.buy_btn)
        end

        --self.btn_goto:setVisible(false)
        --self.btn_get:setVisible(false)
        --self.has_bg:setVisible(false)
        --
        --self.price_1:setString(data.price1)
        --self.price_2:setString(data.price2)
        --if self.serve_list[self.data._index].status == 0 then
        --    self.half_panel:setVisible(true)
        --    self.has_bg:setVisible(false)
        --    self.textGet:setString(TI18N("剩余: 1"))
        --else
        --    self.half_panel:setVisible(false)
        --    self.has_bg:setVisible(true)
        --    self.textGet:setString(TI18N("剩余: 0"))
        --end
    end

    --if self.type ~= 4 then
    --    if self.serve_list[self.data._index].status == 1 then--可领取
    --        self.type1:setVisible(false)
    --        self.type2:setVisible(true)
    --    else
    --        if self.serve_list[self.data._index].status == 0 then--未达成
    --            self.type1_goto_btn:setVisible(true)
    --            self.type1_finish_btn:setVisible(false)
    --        else--已完成
    --            self.type1_goto_btn:setVisible(false)
    --            self.type1_finish_btn:setVisible(true)
    --        end
    --        self.type1:setVisible(true)
    --        self.type2:setVisible(false)
    --    end
    --    --self.half_panel:setVisible(false)
    --    --self.btn_goto:setVisible(self.serve_list[self.data._index].status == 0)
    --    --self.btn_get:setVisible(self.serve_list[self.data._index].status == 1)
    --    --self.has_bg:setVisible(self.serve_list[self.data._index].status == 2)
    --    --if self.init_cur_day and self.cur_day > self.init_cur_day then
    --    --    self.btn_goto:setVisible(true)
    --    --    self.btn_goto:setTitleText(TI18N("未解锁"))
    --    --    setChildUnEnabled(true, self.btn_goto)
    --    --    self.btn_goto_label:disableEffect(cc.LabelEffect.OUTLINE)
    --    --    self.btn_goto:setTouchEnabled(false)
    --    --    self.btn_get:setVisible(false)
    --    --    self.has_bg:setVisible(false)
    --    --else
    --    --    setChildUnEnabled(false, self.btn_goto)
    --    --    self.btn_goto_label:enableOutline(Config.ColorData.data_color4[278], 2)
    --    --    self.btn_goto:setTouchEnabled(true)
    --    --end
    --end
end

function ActionSevenGoalItem2:register_event( )
    --registerButtonEventListener(self.type2_get_btn, function()
    --    ActionController:getInstance():cs13602(self.type, self.cur_day, self.serve_list[self.data._index].goal_id, self.data._index)
    --end,true, 1)
    --
    --registerButtonEventListener(self.type1_goto_btn, function()
    --    StrongerController:getInstance():clickCallBack(self.data.show_icon)
    --    ActionController:getInstance():openSevenGoalView(false)
    --end,true, 1)

    registerButtonEventListener(self.buy_btn, function()
        ActionController:getInstance():cs13602(self.type, self.cur_day, self.data.id, self.data._index)
    end,true, 1)
end

function ActionSevenGoalItem2:DeleteMe()
    --if self.item_scrollview then
    --    self.item_scrollview:DeleteMe()
    --    self.item_scrollview = nil
    --end
    if self.goods_list and next(self.goods_list or {}) ~= nil then
        for i, v in ipairs(self.goods_list) do
            if v.DeleteMe then
                v:DeleteMe()
            end
        end
    end
    self:removeAllChildren()
    self:removeFromParent()
end